package de.ozgcloud.formcycle.formdata;

import static de.ozgcloud.formcycle.formdata.ItemClass.*;
import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;

class ItemClassTest {

	@Nested
	@DisplayName("Is root method")
	class TestRootContainers {

		@Test
		@DisplayName("should confirm header")
		void shouldConfirmHeaderAsRoot() {
			assertTrue(isRootContainer(HEADER));
		}

		@Test
		@DisplayName("should confirm page")
		void shouldConfirmPageAsRoot() {
			assertTrue(isRootContainer(PAGE));
		}

		@Test
		@DisplayName("should confirm footer")
		void shouldConfirmFooterAsRoot() {
			assertTrue(isRootContainer(FOOTER));
		}
	}


	@Nested
	@DisplayName("Is nested container method")
	class TestNestedContainer {

		@Test
		@DisplayName("should confirm field set")
		void shouldConfirmFieldSet(){
			assertTrue(isNestedContainer(FIELD_SET));
		}

		@Test
		@DisplayName("should confirm container nodelll")
		void shouldConfirmContainer(){
			assertTrue(isNestedContainer(CONTAINER));
		}
	}

	@Nested
	@DisplayName("Is input node method")
	class TestInputElement{

		@Test
		@DisplayName("should confirm text field")
		void shouldConfirmTextField(){
			assertTrue(isInputNode(TEXT_FIELD));
		}

		@Test
		@DisplayName("should confirm text area")
		void shouldConfirmTextArea(){
			assertTrue(isInputNode(TEXT_AREA));
		}

		@Test
		@DisplayName("should confirm select")
		void shouldConfirmSelect(){
			assertTrue(isInputNode(SELECT));
		}

		@Test
		@DisplayName("should confirm checkbox")
		void shouldConfirmCheckbox(){
			assertTrue(isInputNode(CHECKBOX));
		}

		@Test
		@DisplayName("should confirm upload")
		void shouldConfirmUpload(){
			assertTrue(isInputNode(UPLOAD));
		}

	}

	@Test
	@DisplayName("should confirm text item")
	void shouldConfirmTextElement(){
		assertTrue(isTextNode(SPAN));
	}

}